/********************************/
/* CD List by Tim Bendel        */
/* June 9, 1994                 */
/*                              */
/* Note that this program was   */
/* written quickly without      */
/* regard for error checking,   */
/* style, technique, form, etc. */
/* Feel free to change the      */
/* program.  If you do so,      */
/* please email me at:          */
/* TBendel@aol.com              */
/********************************/


/* This was written and tested on a PowerMac 6100/60 AV with an internal CD Rom drive */


#include <Dialogs.h>
#include <Quickdraw.h>


#define ORIG_FILE         0
#define USER_FILE         1
#define BASE_RES_ID       128
#define NIL               0L
#define MOVE_TO_FRONT     -1L
#define REMOVE_ALL_EVENTS 0

#define MIN_SLEEP         0L
#define NIL_MOUSE_REGION  0L  

#define WNE_TRAP_NUM      0x60
#define UNIMPL_TRAP_NUM   0x9F


#define PREF_ITEM         8
#define CLEAR_ITEM        6
#define PASTE_ITEM        5
#define COPY_ITEM         4
#define DELETE_ITEM       2
#define TEST_ITEM         3
#define CLOSE_ITEM        5
#define GRID_ITEM         6
#define NEW_ITEM          1
#define EDIT_ITEM         1
#define ABORT_ITEM        2
#define SAVE_ITEM         4
#define QUIT_ITEM         2
#define ABOUT_ITEM        1
#define YES               1
#define NO                0
#define DONE              3
#define SAVE_BUTTON       11
#define CANCEL_BUTTON     12
#define ON                1
#define OFF               0
#define NO_FLAGS          0L
#define NOT_A_NORMAL_MENU -1
#define APPLE_MENU_ID     128
#define FILE_MENU_ID      129
#define EDIT_MENU_ID      130

#define ABOUT_ALERT       400

typedef struct cdstruct {

   int idnum;
   char title[40];
   };


typedef struct CDStruct {
   
   char           title[40];
   short          numsongs;
   char           song[30][40];
   };

pascal   OSErr  SetDialogDefaultItem(DialogPtr theDialog, short newItem)
     = { 0x303C, 0x0304, 0xAA68};
pascal   OSErr  SetDialogCancelItem(DialogPtr theDialog, short newItem)
     =  {0x303C, 0x0305, 0xAA68};
pascal   OSErr  SetDialogTracksCursor(DialogPtr theDialog, Boolean tracks)
     =  {0x303C, 0x0306, 0xAA68};


WindowPtr    listwind;
DialogPtr    aboutdlg,newd;
Boolean      gDone,gWNEImplemented;
EventRecord  gTheEvent;
MenuHandle   AppleMenu,FileMenu,EditMenu;
struct CDStruct acd;
struct cdstruct cds[200];


main() {
   
   GDHandle curdev;
   int pixdepth;
   GrafPtr oldport;
   Handle song;
   Rect temprect;
   
   MaxApplZone();
   ToolBoxInit();

       
   if (IsColor()) {
      curdev = GetDeviceList();
      WindowInit();
      MenuBarInit();
      DialogInit();
            
      FlushEvents( everyEvent, REMOVE_ALL_EVENTS);
      MainLoop();      
      
      }
   else {
      StopAlert(130,NIL);
      ExitToShell();
      }
   }

IsColor() {

   SysEnvRec mySE;
   
   SysEnvirons(2,&mySE);
   if (!mySE.hasColorQD)
      return(FALSE);
   else
      return(NGetTrapAddress(0xAB03,ToolTrap)!=NGetTrapAddress(0xA89F,ToolTrap));
   }

GetPixelDepth(GDHandle thedevice) {

   PixMapHandle screenPMapH;
   int          pixeldepth;
   
   screenPMapH = (**thedevice).gdPMap;
   pixeldepth = (**screenPMapH).pixelSize;
   return(pixeldepth);
   }

DoAlert(Str255 s) {

   ParamText(s,"/p","/p","/p");
   NoteAlert(128,0L);
   }   

DoAlert2(Str255 s) {

   ParamText("/p",s,"/p","/p");
   NoteAlert(129,0L);
   }   

/***********************/ 
/* Initializes toolbox */
/***********************/   
ToolBoxInit() {

   InitGraf( &thePort );
   InitFonts();
   FlushEvents( everyEvent, REMOVE_ALL_EVENTS);
   InitWindows();
   InitMenus();
   TEInit();
   InitDialogs( NIL );
   InitCursor();
   } 

/********************/ 
/* Gets game window */
/********************/   
WindowInit() {
   
   listwind = GetNewWindow(128,NIL,0);
   SetPort(listwind);
   }

/***********************/ 
/* Initializes MenuBar */
/***********************/      
MenuBarInit() {

   Handle myMenuBar;
   
   myMenuBar = GetNewMBar(BASE_RES_ID);
   SetMenuBar( myMenuBar);
   AppleMenu = GetMHandle(APPLE_MENU_ID); 
   FileMenu = GetMHandle(FILE_MENU_ID);
   EditMenu = GetMHandle(EDIT_MENU_ID);
   AddResMenu(AppleMenu,'DRVR');
   DrawMenuBar();   
   DisableItem(EditMenu,CLEAR_ITEM);                            
   DisableItem(EditMenu,PASTE_ITEM);                            
   DisableItem(EditMenu,COPY_ITEM);                            
   }

/*******************/
/* Sets Up Dialogs */
/*******************/
DialogInit() {
      
   aboutdlg = GetNewDialog(134,NIL,0); 
   }      

/**************************/
/* Loops until user quits */
/**************************/
MainLoop() {  
   int a,x,y,dx,dy;
   Str255 ts,myString;
   int itemhit,itemtype;
   Rect itemrect;
   Handle itemhandle;
   int temp; 
   GrafPtr    savePort;
   
   gDone = FALSE;
   gWNEImplemented = (NGetTrapAddress(WNE_TRAP_NUM, ToolTrap) !=
                      NGetTrapAddress(UNIMPL_TRAP_NUM, ToolTrap));
   
   while(gDone == FALSE) {       

      /********************************/
      /* Mac events are taken care of */
      /********************************/
      HandleEvent(); 
      }
   }
   

HandleEvent() {

   char theChar;
   int  itemhit;
   
    HiliteMenu(0);
   /***********************/   
   /* Gets the next event */
   /***********************/   
   if (gWNEImplemented) {
      WaitNextEvent(everyEvent,&gTheEvent,MIN_SLEEP,NIL_MOUSE_REGION);
      }   
    else {
      SystemTask();
      GetNextEvent(everyEvent,&gTheEvent);
      }
   
    /*****************************************************/
    /* When an event happens, the proper action is taken */
    /*****************************************************/
    switch(gTheEvent.what) {
   
      case nullEvent: HandleNull();
                      break;
                      
      case mouseDown: 
                      HandleMouseDown();
                      break;
                      
      case keyDown:   
      case autoKey:   theChar = gTheEvent.message & charCodeMask;
                      if ((gTheEvent.modifiers & cmdKey) != 0)
                         HandleMenuChoice(MenuKey(theChar));
                       break;
                      
      case updateEvt: BeginUpdate((WindowPtr)gTheEvent.message);
                      if ((WindowPtr)gTheEvent.message == listwind) {
                        }
  
                      EndUpdate((WindowPtr)gTheEvent.message); 
                      break;
      case app4Evt:
		              break;
} 
   }
                      
                      
 HandleMouseDown() {
 
    WindowPtr  whichWindow;
    short      thePart;
    long       menuChoice,windSize;
    Point      thePoint;
    
    thePart = FindWindow(gTheEvent.where, &whichWindow);
    /*********************************************************/
    /* Takes action based on where the mouse is when pressed */
    /*********************************************************/
    switch(thePart) {
    
       case inMenuBar:    menuChoice = MenuSelect(gTheEvent.where);
                          HandleMenuChoice(menuChoice);
                          break;
                       
       case inSysWindow : SystemClick(&gTheEvent,whichWindow);
                          break;
       case inContent   : break;
       }
       
    }
    
 /****************************/
 /* Controls pull-down menus */
 /****************************/
 HandleMenuChoice(menuChoice) 
    long int menuChoice; {
    
    int theMenu;
    int theItem;
    
    if (menuChoice != 0) {
       
       theMenu = HiWord(menuChoice);
       theItem = LoWord(menuChoice);
       
       switch(theMenu) {
          case APPLE_MENU_ID : HandleAppleChoice(theItem);
                               break;
     
          case FILE_MENU_ID  : HandleFileChoice(theItem);
                               break;
     
 
          case EDIT_MENU_ID  : HandleEditChoice(theItem);
                               break;
     
 
          default :    
                               HandleFileChoice(theItem);
                               break;
          }
          
          HiliteMenu(0);
       }
    }
    
/********************************/
/* Takes care of the apple menu */
/********************************/
 HandleAppleChoice(theItem)
    int theItem; {
    
    Str255     accName;
    int        accNumber,itemhit;
    short int  itemNumber;
    GrafPtr    savePort;
      
    /***********************************************************/
    /* Displays the About dialog or handles the desk accessory */
    /***********************************************************/
    switch(theItem) {
              
       case ABOUT_ITEM :
		                 GetPort(&savePort);
                         ShowWindow(aboutdlg);
                         SelectWindow(aboutdlg);                         
                         SetDialogDefaultItem(aboutdlg,1);
                         ModalDialog(NULL,&itemhit);
                         HideWindow(aboutdlg);   
		                 SetPort(savePort);
                         break;
                            
       default         : 
		                 GetPort(&savePort);
		                 GetItem(AppleMenu, theItem,accName);
		                 OpenDeskAcc(accName);
		                 SetPort(savePort);
                         break;
       }
    }
 
 

 HandleFileChoice(theItem)
    int theItem; {
    
    DialogPtr quitd,dialog;
    Handle soundh;
    int itemhit;
    int a;
    GrafPtr savePort;
    StandardFileReply    *filename;
           
    switch(theItem) {
       
       case QUIT_ITEM  :     
                         quitd = GetNewDialog(132,NIL,0);
		                 GetPort(&savePort);
                         ShowWindow(quitd);
                         SelectWindow(quitd);
                         SetPort(quitd);
                         SetDialogDefaultItem(quitd,1);
                         SetDialogCancelItem(quitd,2);
                         ModalDialog(NULL,&itemhit);
   
                         if (itemhit == 1)     
                            gDone = TRUE;
                         
                         HideWindow(quitd);   
		                 DisposDialog(quitd);
		                 SetPort(savePort); 
                         break;
       
      case NEW_ITEM   :  HandleNewChoice();
                         break; 
       }   
    }
     
HandleEditChoice(theItem)
    int theItem; { }
   
HandleNull() { }
                  
   

HandleNewChoice() {
   

   Str255                   rName,theString;
   long                     iErr,bufsize,bsize;
   short                    iFileRef,iCnt,rID,index,fRefNum;
   int                      a,i; 
   Handle                   hRsrc,prog;
   ResType                  thetype,rType,ptype;
   char                     *thenum;
   Point                    thepoint;
   SFTypeList               typeList;
   SFReply                  reply,reply2;
   
   /******************/
   /* Get File Names */
   /******************/
   typeList[0] = 'ProG';
   thepoint.h = thepoint.v = 100;
   SFGetFile(thepoint, NIL, NIL, 1, typeList, NIL, &reply);
   if (reply.good == TRUE) {
      SFPutFile(thepoint, NIL, "\pMy CD List", NIL, &reply2);
      if (reply2.good == TRUE) {

         /******************/
         /* Open List File */
         /******************/
         iErr = Create( reply2.fName, reply2.vRefNum, 'MSWD', 'TEXT');
         iErr = FSOpen ( reply2.fName, reply2.vRefNum, &fRefNum );
  		 if (iErr == 0) {  
            bufsize = sizeof(Str255);             
            iErr = SetFPos ( fRefNum, fsFromStart,0);                            
       
            /******************************/
            /* Get Resource as Read Only  */
            /******************************/
            thetype = 'STR#';
            ptype = 'ProG';
            iFileRef = OpenRFPerm(reply.fName,reply.vRefNum,1);
            iCnt = Count1Resources(thetype);
            
            /*********************/
            /* Get Song Res ID's */
            /*********************/
            for (a=1;a<=iCnt;++a) {
               hRsrc = Get1IndResource(thetype, a); 
               GetResInfo(hRsrc, &rID, &rType, rName);
               cds[a - 1].idnum = rID;
               clearstring(theString);            
               GetIndString(theString, rID, 1);
               copytostring(theString,cds[a - 1].title);
               }
            
            /*********************/
            /* Sort CD Titles    */
            /*********************/
            stripper(iCnt);
            bubblesort(iCnt);
              
            /*******************/
            /* Get Song Titles */
            /*******************/
            for (a=1;a<=iCnt;++a) {
	           prog = Get1Resource(ptype, cds[a -1].idnum);
               HLock(prog);
               thenum = *prog;
               index = thenum[1]; 
               HUnlock(prog);
               acd.numsongs = index;
               clearstring(theString);            
               GetIndString(theString, cds[a -1].idnum, 1);
               copytostring(theString,acd.title);
               
               for (i = 2;i<=index + 1;++i) {
                  clearstring(theString);            
                  GetIndString(theString, cds[a -1].idnum, i); 
                  copytostring(theString,acd.song[i - 1]);
                  }                               
               
               
               /************************/
               /* Write titles to file */
               /************************/
               bufsize = 40 * sizeof(char);
               iErr = FSWrite( fRefNum, &bufsize, &acd.title);                                                 
               clearstring(theString);
               copytostring(theString,acd.song[0]);
                for (i = 0;i <= acd.numsongs;++i)
                  iErr = FSWrite( fRefNum, &bufsize, &acd.song[i]);                                                   
                for (i = 0;i <= 2;++i)
                  iErr = FSWrite( fRefNum, &bufsize, &acd.song[0]);                                                   
               }
            FSClose(fRefNum);
            CloseResFile(iFileRef);
            }
         else {
            DoAlert2("\pError Saving List");
            iErr = FSClose(fRefNum);
            }
         }
      else {
         DoAlert2("\pError Opening File");
         iErr = FSClose(fRefNum);
         }
      }
   }

         


clearstring(Str255 dest) {

   int a;
   
   for (a = 0;a < 255;++a)
      dest[a] = ' ';
  }

copytostring(Str255 source,char *dest) {

   int a;
   
   for (a = 0;a < 40;++a)
      dest[a] = ' ';
      
   for (a = 0;a < 40;++a)
      dest[a] = source[(a + 1)];
   dest[39] = 13;
   }


/*************************/
/* Used in alphabetizing */
/*************************/
stripper(int MAXNUM) {
   int a,b;

   for (a=0;a < MAXNUM;++a) {
      for (b = 0;b < 40;++b)
	 
	 /*************************************/
	 /* Changes all letters to lower-case */
	 /*************************************/
	 if ((cds[a].title[b] >= 'A') && (cds[a].title[b] <= 'Z'))
	    cds[a].title[b] += 32;
      
      /***************************************/
      /* Takes off the word 'the' if present */
      /***************************************/
      if ((cds[a].title[0] == 't') &&
	  (cds[a].title[1] == 'h') &&
	  (cds[a].title[2] == 'e')) {
	  for (b = 0;b < 35;++b)
	     cds[a].title[b] = cds[a].title[b + 4];
	  cds[a].title[36] = ' ';
	  cds[a].title[37] = ' ';
	  cds[a].title[38] = ' ';
       /*	  cds[a].title[29] = 13;     */
	  }
      }
   }

/*******************************/
/* Simple Buublesort alogrithm */
/*******************************/
bubblesort(int MAXNUM) {

   int i,j;
   struct cdstruct temp;

   for(i = 0;i < MAXNUM;++i) {
      for (j = (MAXNUM - 1);j >= i;--j) {
	 if(alphabet(i,j) == 1) {
	    temp = cds[i];
	    cds[i] = cds[j];
	    cds[j] = temp;
	    }
	 }
      }
   }


/*****************************/ 
/* Checks alphabetical order */
/*****************************/ 
alphabet(int i,int j) {
   int a,b;

   a = 0;

   while ((cds[i].title[a] == cds[j].title[a])  && (a < 29))
      ++a;

   if (cds[i].title[a] > cds[j].title[a])
      return(1);
   else
      return(0);

   }  